/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/
/*
  Alle Bloecke, die im CodedImage durch 'm_CodeXX[X]' gekennzeichnet sind,
  werden transformiert. Danach koennen diese Flags dann immer noch auf
  false gesetzt werden.
*/

#ifndef CODING_DCT_COUPLED_HH
#define CODING_DCT_COUPLED_HH

#include "coding/dct_separated.hh"
#include "math/dct2_arai.hh"
#include "math/dct2_arai_int.hh"
#include "image/image.hh"
#include "image/codedimg.hh"

template <class Pel> class DCTCoder_Coupled : public DCTCoder_Separated<Pel>
{
public:
  //   DCTCoder_Coupled() { }
  //~DCTCoder_Coupled() { }

  void EnableQuantization(bool flag=true);
  void SetChromaFormat(uint2 chroma_format);
  // void SetQuantizerMatrix(enum which,Matrix&);

  void SetQScaleType (uint1 qscale_type);
  void SetDCPrecision(uint8 dc_precision);

  void MBlk_FDCTQuant(const Image<Pel>& img,int mbx0,int mby0,Macroblock& mb);

private:
  uint1 d_q_scale_type;          // Ob die berechneten Skal.fakt. einem nichtlin. qcode entsprechen.
  uint8 d_dc_precision;          // DC-Precision der Skal.fakt.
  bool  d_recalc_scalefacts;     // Ob die Skalierungsfaktoren neu berechnet werden muessen.
  DCT2_AraiAguiNakajima_Int d_dct[2 /* 0 Intra / 1 Inter */]
                                 [2 /* 0 Lumi  / 1 Chrom */]
                                 [32]; // Fuer jeden qscale-Faktor ein DCT2. [][0] ist nur Dummy.
  uint8 d_chromaxfact,d_chromayfact;

  void  PrecalcQMatrix();
};

#endif
