/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/
/*
  Alle Bloecke, die im CodedImage durch 'm_CodeXX[X]' gekennzeichnet sind,
  werden transformiert. Danach koennen diese Flags dann immer noch auf
  false gesetzt werden.
*/

#ifndef CODING_DCT_SEPARATED_HH
#define CODING_DCT_SEPARATED_HH

#include "coding/dct.hh"
#include "math/dct2_arai.hh"
#include "math/dct2_arai_int.hh"
#include "image/image.hh"
#include "image/codedimg.hh"


template <class Pel> class DCTCoder_Separated : public DCTCoder<Pel>
{
public:
   DCTCoder_Separated() { }
  ~DCTCoder_Separated() { }

  void SetChromaFormat(uint2 chroma_format);

  void SetQScaleType (uint1 qscale_type);
  void SetDCPrecision(uint8 dc_precision);

  void MBlk_FDCTQuant(const Image<Pel>& img,int mbx0,int mby0,Macroblock& mb)
    {
      MBlk_FDCT(img,mbx0,mby0,mb);
      MBlk_Quant(mb,mb);
    }
  void MBlk_FDCT (const Image<Pel>&,int mbx0,int mby0,Macroblock& mb);
  void MBlk_Quant(const Macroblock& in,Macroblock& out);

private:
  uint1 d_q_scale_type;          // Ob die berechneten Skal.fakt. einem nichtlin. qcode entsprechen.
  uint8 d_dc_precision;          // DC-Precision der Skal.fakt.
  bool  d_recalc_scalefacts;     // Ob die Skalierungsfaktoren neu berechnet werden muessen.
  DCT2_AraiAguiNakajima_Int d_dct;
  uint8 d_chromaxfact,d_chromayfact;

  short d_QMatrix[32][8][8];
  void  PrecalcQMatrix();

  short* d_inter[32];
  short  d_qinter[32][4096];
};

#endif
