/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef CONTROL_TASKPOOL_PICSTAT_HH
#define CONTROL_TASKPOOL_PICSTAT_HH

#include <control/taskpool.hh>

/*
  Berechnet fuer alle Eingabebilder "Mean","Variance" und die jeweiligen Differenzen zum
  letzten Bild. Die Ergebnisse werden aus cout ausgegeben und koennen mittels gnuplot
  angezeigt werden.
*/


class TaskPool_PicStat : public TaskPool
{
public:
  TaskPool_PicStat(class InputPreprocessor&);
  ~TaskPool_PicStat();

  bool  Finished();
  Task* GetTask();
  void  TaskCompleted(Task*);

private:
  class InputPreprocessor& d_preproc;
  Queue<Task*> d_set; // Eine (geordnete) Menge waere besser
};

#endif
