/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef CONTROL_TASKWRITE_HH
#define CONTROL_TASKWRITE_HH

#include "control/taskpool.hh"

/*
  Erzeugt den Bitstream eines Frames und der ggf. davor befindlichen SeqHdr und GOP-Hdr.
  Der Bitstream wird im 'BitBuffer' zwischengespeichert, der an jedem ImageData haengt.
  Dieser muss spaeter noch mit einem 'Task_WriteToStream' gespeichert werden.
 */

class Task_WriteFrame : public Task
{
public:
  Task_WriteFrame(int framenr)
    : m_framenr(framenr) { }

  void Execute(ProcessData&);

  const int m_framenr;
};


class Task_WriteToStream : public Task
{
public:
  Task_WriteToStream(int framenr,class StreamSink& sink)
    : m_framenr(framenr), m_sink(sink) { }

  void Execute(ProcessData&);

  const int m_framenr;
  class StreamSink& m_sink;
};

#endif


