/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef DISABLE_MJPEG
#define DISABLE_MJPEG 0
#endif

extern int nullcnt,notnullcnt;
extern int n_right,n_false;

int ibuf[8][8];
int fbuf[8][8];

int accerror[8][8];
int totalacc;

int err=0;
int abserr=0;

bool DisableSomething=false;

#include "types.hh"
#include "input/preproc_sglfrms.hh"
#include "image/image.hh"
#include "output/streamsink_ostr.hh"
#include "output/bitbuffer.hh"
//#include "control/encoder_simple.hh"
#include "options.hh"
#include "version.hh"


#include "control/codingloop.hh"
#include "control/taskpool_picstat.hh"
#include "control/taskpool_regular.hh"
#include "control/taskpool_allinone.hh"

#if USE_MMX
#include "arch/MMX/mmx.hh"
#endif

#if USE_VIS
#include "arch/VIS/vischk.hh"
#endif

#if !DISABLE_MJPEG
#include "input/preproc_miro_avi.hh"
#include "input/preproc_avi.hh"
#endif

#if !DISABLE_V4L
#include "input/preproc_v4l.hh"
#include "input/preproc_v4l_sglstep.hh"
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>
#include <sys/times.h>
#include <unistd.h>
#ifdef LINUX
#include <linux/param.h>
#else
#endif

#if HAVE_GETOPT_LONG
#include <getopt.h>
#else
struct option
{
  const char *name;
  int has_arg;
  int *flag;
  int val;
};
#endif

#if 0
#include "math/dct2_arai.hh"
#include "math/dct2_arai_int.hh"

void runtests()
{
  ibuf[0][0]=1; fbuf[1][1]=1;

#if 0
  short  in[8][8];
  const short* inp[8];
  for (int i=0;i<8;i++)
    inp[i]=in[i];

  for (int v=0;v<8;v++)
    for (int u=0;u<8;u++)
      in[v][u] = ((rand()%512)-256);

  DCTBlock out,out2;
  DCT2_AraiAguiNakajima     fdct;
  DCT2_AraiAguiNakajima_Int fdct_int;

  fdct.PerformFDCT2(inp,out);
#if 0
  cout << "FLOAT:\n";
  for (int y=0;y<8;y++,cout << endl)
    for (int x=0;x<8;x++)
      cout << setw(5) << (int)out.m_coeff[y][x] << ' ';
#endif

  cout << endl;

  fdct_int.PerformFDCT2(inp,out2);
#if 0
  cout << "INT:\n";
  for (int y=0;y<8;y++,cout << endl)
    for (int x=0;x<8;x++)
      cout << setw(5) << (int)out2.m_coeff[y][x] << ' ';
#endif

#if 1
  cout << endl;
  int error=0,abserror=0;
  for (int y=0;y<8;y++,cout << endl)
    for (int x=0;x<8;x++)
      {
        int d;
        cout << setw(5) << (d=out.m_coeff[y][x]-out2.m_coeff[y][x]) << ' ';
        error+=d; abserror+=abs(d);

        accerror[x][y] += d;
        totalacc+=d;
      }
  cout << "Error: " << error << " AbsError: " << abserror << endl;
  cout << endl;

  cout << "\nAkkumulierter Fehler:\n";
  for (int x=0;x<8;x++,cout << endl)
    for (int y=0;y<8;y++)
      {
        cout << setw(5) << accerror[x][y] << ' ';
      }
  cout << "TOTAL: " << totalacc << endl;
#endif

#if 0
  for (int x=0;x<8;x++,cout << endl)
    for (int y=0;y<8;y++)
      {
        cout << setw(5) << ibuf[x][y]-fbuf[x][y] << ' ';
        /*
        if (abs(ibuf[x][y]-fbuf[x][y]) > 1)
          cout << "Diff > 1 !!!\n";
        */
        err += ibuf[x][y]-fbuf[x][y];
        abserr += abs(ibuf[x][y]-fbuf[x][y]);
      }

  cout << "Error: " << err << "  AbsError: " << abserr << endl;
#endif

#else
  DCTBlock in;
  for (int v=0;v<8;v++)
    for (int u=0;u<8;u++)
      in.m_coeff[v][u] = ((rand()%409)-204);

  uint8  out[8][8];
  uint8* outp[8];
  uint8  out2[8][8];
  uint8* outp2[8];
  for (int i=0;i<8;i++)
    { outp[i]=out[i]; outp2[i]=out2[i]; }

  IDCT2_AraiAguiNakajima     idct;
  IDCT2_AraiAguiNakajima_Int idct_int;

  idct    .PerformIDCT2Blk(in,outp ,false);
  idct_int.PerformIDCT2Blk(in,outp2,false);

#if 0
  cout << "FLOAT:\n";
  for (int y=0;y<8;y++,cout << endl)
    for (int x=0;x<8;x++)
      cout << setw(4) << (int)out[y][x] << ' ';

  cout << endl;

  cout << "INT:\n";
  for (int y=0;y<8;y++,cout << endl)
    for (int x=0;x<8;x++)
      cout << setw(4) << (int)out2[y][x] << ' ';

  cout << endl;
#endif

  int error=0,abserror=0;
  cout << "Error:\n";
  for (int y=0;y<8;y++,cout << endl)
    for (int x=0;x<8;x++)
      {
        int d;
        cout << setw(5) << (d=out[y][x]-out2[y][x]) << ' ';

        error+=d; abserror+=abs(d);

        accerror[x][y] += d;
        totalacc+=d;
      }
  cout << "Error: " << error << " AbsError: " << abserror << endl;
  cout << endl;

  cout << "\nAkkumulierter Fehler:\n";
  for (int x=0;x<8;x++,cout << endl)
    for (int y=0;y<8;y++)
      {
        cout << setw(5) << accerror[x][y] << ' ';
      }
  cout << "TOTAL: " << totalacc << endl;
#endif
}
#endif


void CheckParameterConsistence()
{
#if 0
  assert((BITMAP_ALIGN % 8)==0);
#if USE_MMX
  if (MMX_Supported)
    {
      assert( sizeof(Pixel)  ==1 );
      assert( sizeof(MVPixel)==1 );
#ifndef MVPIX_IS_PIX
      assert(0);
#endif
    }
#endif
#endif
}


enum CommandLineOptions {
  // Optionen mit Einzeichen-Aequivalent

  Opt_MPEG1             = '1',
  Opt_MPEG2             = '2',
  Opt_FirstFrameToLoad  = 's',
  Opt_LastFrameToLoad   = 'e',
  Opt_TargaInput        = 't',
  Opt_FixedQScale       = 'q',
  Opt_ExponentialQScale = 'x',
  Opt_IntraDCPrecision  = 'd',
  Opt_AlternateScan     = 'a',
  Opt_IntraVLCFormat1   = 'f',
  Opt_GOPLength         = 'g',
  Opt_PDistance         = 'p',
  Opt_FullSearch        = 'F',
  Opt_TSS               = '3',
  Opt_OTS               = 'O',
  Opt_Help              = 'h',
  Opt_Visualize         = 'v',
  Opt_ShowRMS           = 'r',
  Opt_MiroAVI           = 'm',
  Opt_Miro_SmallPic     = 'S',
  Opt_SearchWin_H       = 'H',
  Opt_SearchWin_V       = 'V',
  Opt_FramePattern      = 'P',
  Opt_Threads           = 'T',
  Opt_ProgressDisplay   = 'D',
  Opt_Bitrate           = 'R',
  Opt_JNDControl        = 'J',
  Opt_LuminanceMasking  = 'B',
  Opt_ActivityMasking   = 'A',
  Opt_MotionMasking     = 'M',
  Opt_SaveAudio         = 'W',
  Opt_Video4Linux       = 'b',
  Opt_DecimationFactor  = 'N',
  Opt_Size              = 'z',
  Opt_NullMV            = '0',
  Opt_DisableVIS = 'X',
  Opt_PPMInput = 'Y',

  // Optionen ohne Einzeichen-Aequivalent

  Opt_DUMMY             = 1000,
  Opt_PPMInterlaced,
  Opt_AccurateMBType,
  Opt_FixedQScale_I,
  Opt_FixedQScale_P,
  Opt_FixedQScale_B,
  Opt_ShowInformation,
  Opt_1DFS,
  Opt_NTSS,
  Opt_Video4LinuxSglStep,
  Opt_DisablePredCorrect,
  Opt_DisableMMX,
  Opt_DisableSomething,
  Opt_CropTop,
  Opt_CropBottom,
  Opt_CropLeft,
  Opt_CropRight,
  Opt_Framerate100
};

static struct option opts[] =
{
  { "mpeg1"            ,0, 0, Opt_MPEG1 },
  { "mpeg2"            ,0, 0, Opt_MPEG2 },
  { "firstframe"       ,1, 0, Opt_FirstFrameToLoad },
  { "lastframe"        ,1, 0, Opt_LastFrameToLoad  },
  { "targa"            ,0, 0, Opt_TargaInput },
  { "ppm"              ,0, 0, Opt_PPMInput },
  { "ppminterlaced"    ,0, 0, Opt_PPMInterlaced },
  { "qscale"           ,1, 0, Opt_FixedQScale },
  { "dcttype1"         ,0, 0, Opt_ExponentialQScale },
  { "intraDCprec"      ,1, 0, Opt_IntraDCPrecision },
  { "alternatescan"    ,0, 0, Opt_AlternateScan },
  { "intraVLCformat1"  ,0, 0, Opt_IntraVLCFormat1 },
  { "GOPlength"        ,1, 0, Opt_GOPLength },
  { "PDistance"        ,1, 0, Opt_PDistance },
  { "fullsearch"       ,0, 0, Opt_FullSearch },
  { "TSS"              ,0, 0, Opt_TSS },
  { "NTSS"             ,0, 0, Opt_NTSS },
  { "OTS"              ,0, 0, Opt_OTS },
  { "1DFS"             ,0, 0, Opt_1DFS },
  { "NullMV"           ,0, 0, Opt_NullMV },
  { "help"             ,0, 0, Opt_Help },
  { "visualizecoding"  ,1, 0, Opt_Visualize },
  { "showRMS"          ,0, 0, Opt_ShowRMS },
  { "miroavi"          ,0, 0, Opt_MiroAVI },
  { "video4linux"      ,0, 0, Opt_Video4Linux },
  { "decimationfactor" ,1, 0, Opt_DecimationFactor },
  { "size"             ,1, 0, Opt_Size },
  { "remoteV4L"        ,0, 0, Opt_Video4LinuxSglStep },
  { "mirosmall"        ,0, 0, Opt_Miro_SmallPic },
  { "nopredcorrect"    ,0, 0, Opt_DisablePredCorrect },
  { "disablesomething" ,0, 0, Opt_DisableSomething },
  { "disablemmx"       ,0, 0, Opt_DisableMMX },
  { "disablevis"       ,0, 0, Opt_DisableVIS },
  { "accurateMBtype"   ,0, 0, Opt_AccurateMBType },
  { "hsearchrng"       ,1, 0, Opt_SearchWin_H },
  { "vsearchrng"       ,1, 0, Opt_SearchWin_V },
  { "framepattern"     ,0, 0, Opt_FramePattern },
  { "threads"          ,1, 0, Opt_Threads },
  { "qscaleI"          ,1, 0, Opt_FixedQScale_I },
  { "qscaleP"          ,1, 0, Opt_FixedQScale_P },
  { "qscaleB"          ,1, 0, Opt_FixedQScale_B },
  { "verbosity"        ,1, 0, Opt_ProgressDisplay },
  { "showinfo"         ,1, 0, Opt_ShowInformation },
  { "bitrate"          ,1, 0, Opt_Bitrate },
  { "jnd"              ,0, 0, Opt_JNDControl },
  { "LumMasking"       ,0, 0, Opt_LuminanceMasking },
  { "ActMasking"       ,0, 0, Opt_ActivityMasking },
  { "MotionMasking"    ,0, 0, Opt_MotionMasking },
  { "saveaudio"        ,1, 0, Opt_SaveAudio },
  { "croptop"          ,1, 0, Opt_CropTop },
  { "cropbottom"       ,1, 0, Opt_CropBottom },
  { "cropleft"         ,1, 0, Opt_CropLeft },
  { "cropright"        ,1, 0, Opt_CropRight },
  { "framerate100"     ,1, 0, Opt_Framerate100 },
  { 0,0,0,0 }
};

static struct
{
  int         opt;
  bool        numarg;
  const char* descr;
} optdescr[] =
  {
    { Opt_MPEG1,             false, "create MPEG-1 streams" },
    { Opt_MPEG2,             false, "create MPEG-2 streams (default)" },
    { Opt_SaveAudio,         false, "extract audio stored in the AVI to PCM file" },
    { Opt_Threads,           true,  "number of threads to be used for encoding (default=1)" },
    { Opt_ProgressDisplay,   true,  "verbosity (0-3). default=2" },
    { Opt_Help,              false, "show this help" },
    { 0,false,"\n" }, // Leerzeile
    { Opt_FirstFrameToLoad,  true,  "number of first input frame (default: 1)" },
    { Opt_LastFrameToLoad,   true,  "number of last input frame" },
    { Opt_TargaInput,        false, "set input file-type to targa" },
    { Opt_PPMInput,          false, "set input file-type to PPM" },
    { Opt_PPMInterlaced,     false, "set input file-type to PPM (with both fields stored in separate files)" },
    { Opt_Video4Linux,       false, "use V4L source as input (real-time encoding)" },
    { Opt_Video4LinuxSglStep,false, "use V4L source as input + use IR control for single step advance" },
    { Opt_DecimationFactor,  true,  " set V4L decimation-factor to n. Only grab every n-th picture. (2)" },
    { Opt_Size,              false, " picture resolution of V4L input dDefault: 384x288)" },
    { Opt_CropTop,           true,  "crop n lines from top of the picture" },
    { Opt_CropBottom,        true,  "crop n lines from the bottom of the picture" },
    { Opt_CropLeft,          true,  "crop n lines from the left side of the picture" },
    { Opt_CropRight,         true,  "crop n lines from the right side of the picture" },
    { Opt_Framerate100,      true,  "force framerate to n/100 frames/s (n=25000 -> 25fps)" },
    { Opt_MiroAVI,           false, "input is a MJPEG-AVI (default)" },
    { Opt_Miro_SmallPic,     false, " reduce interlaced MJPEG-AVIs to quarter resolution" },
    { 0,false,"\n" }, // Leerzeile
    { Opt_Bitrate,           true,  "set bitrate (in Mb/s) und activate CBR-coding" },
    { Opt_LuminanceMasking,  false, "activate luminance-masking" },
    { Opt_ActivityMasking,   false, "activate activity-masking" },
    { Opt_MotionMasking,     false, "activate motion-masking" },
    { Opt_JNDControl,        false, "activate JND-map-calculation (JND=just noticeable difference)" },
    { Opt_FixedQScale,       true,  "set quantisation-scale to N (1-31) ; default=8" },
    { Opt_FixedQScale_I,     true,  "set I-frame quantisation-scale" },
    { Opt_FixedQScale_P,     true,  "set P-frame quantisation-scale" },
    { Opt_FixedQScale_B,     true,  "set B-frame quantisation-scale" },
    { Opt_ExponentialQScale, false, "select exponential qcode -> qscale ; default=linear (MPEG2)" },
    { Opt_IntraDCPrecision,  true,  "set intra-DC-precision to N (8-11) ; Default=8      (MPEG2)" },
    { Opt_AlternateScan,     false, "use 'Alternate Scan'                                (MPEG2)" },
    { Opt_IntraVLCFormat1,   false, "use intra_vlc_format=1                              (MPEG2)" },
    { Opt_GOPLength,         true,  "set GOP length         ; default=20 (for EncoderControl_Simple)" },
    { Opt_PDistance,         true,  "set P-picture distance ; default= 5 (for EncoderControl_Simple)" },
    { 0,false,"\n" }, // Leerzeile
    { Opt_FullSearch,        false, "perform MV-search using 2DFS (Full Search)" },
    { Opt_TSS,               false, "perform MV-search using TSS  (Three Step Search) (default)" },
    { Opt_NTSS,              false, "perform MV-search using NTSS (New Three Step Search)" },
    { Opt_OTS,               false, "perform MV-search using OTS  (One at a time Search)" },
    { Opt_1DFS,              false, "perform MV-search using 1DFS (One Dimensional Full Search)" },
    { Opt_NullMV,            false, "set all MVs to zero vector" },
    { Opt_SearchWin_H,       true,  "horizontal search range (in pixels, preferably 2^n)" },
    { Opt_SearchWin_V,       true,  "vertical   search range (in pixels, preferably 2^n)" },
    { Opt_AccurateMBType,    false, "determine MB-mode by minimizing of number of output bits" },
    { Opt_FramePattern,      false, "determine picture coding types by fixed pattern (disable scene-change detection)" },
    { 0,false,"\n" }, // Leerzeile
    { Opt_ShowRMS,           false, "calculate RMS-error of output pictures" },
    { Opt_Visualize,         false, "save pictures visualizing encoding process" },
    { Opt_ShowInformation,   false, "enable some informational output (debugging only)" },
    { Opt_DisablePredCorrect,false, "disable praediction-correction (debugging only)" },
#if USE_MMX
    { Opt_DisableMMX,        false, "disable MMX-code (debugging only)" },
#endif
#if USE_VIS
    { Opt_DisableVIS,        false, "disably VIS-code (debugging only)" },
#endif
    { Opt_DisableSomething,  false, "disably something (debugging only)" },
    //{ 0,false,"\n" }, // Leerzeile
    { 1,false,0 } // ENDE
  };

static char spaces[101];

void usage(const char* prgname)
{
  {for (int i=0;i<100;i++)
    spaces[i]=' ';}
  spaces[100]=0;


  cerr << " " PRG_NAME "   " PRG_VERSION "  (" PRG_DATE ")                     Dirk Farin\n"
    "-------------------------------------------------------------------\n"
    " syntax: " << prgname << " [options] <input-filename-pattern>  <output-filename>\n"
    "\n"
    "options:\n";


  // --- Programmoptionen ausgeben ---

  unsigned int maxoptnamelen = 0;
  for (int n=0;opts[n].name;n++)
    {
      if (strlen(opts[n].name) > maxoptnamelen)
        maxoptnamelen = strlen(opts[n].name);
    }

  for (int i=0 ; !(optdescr[i].descr==NULL && optdescr[i].opt==1) ; i++)
    {
      if (optdescr[i].opt==0)
	{ cerr << optdescr[i].descr; continue; }

      bool shortopt;

      if (optdescr[i].opt < 1000) { cerr << "  -" << (char)optdescr[i].opt; shortopt=true; }
      else                        { cerr << "    "; shortopt=false; }

      int n=-1;
      for (int nn=0;opts[nn].name;nn++)
	if (opts[nn].val == optdescr[i].opt)
	  { n=nn; break; }

      if (n>=0 && shortopt) cerr << ", ";
      else                  cerr << "  ";

      if (n>=0) cerr << "--" << opts[n].name;
      else cerr << "  ";

      if (opts[n].has_arg == 0) cerr     << "      ";
      if (optdescr[i].numarg)
	{
	  if (opts[n].has_arg == 1) cerr << "=NUM  ";
	  if (opts[n].has_arg == 2) cerr << "(=NUM)";
	}
      else
	{
	  if (opts[n].has_arg == 1) cerr << "=TXT  ";
	  if (opts[n].has_arg == 2) cerr << "(=TXT)";
	}

      if (n>=0) cerr << &spaces[100-maxoptnamelen+strlen(opts[n].name)];
      else      cerr << &spaces[100-maxoptnamelen];

      cerr << " " << optdescr[i].descr << endl;
    }

#if 0
  // --- Konfiguration ausgeben ---

#if defined (__i386__) || defined (__i386) || defined(i386)
  cerr << "\nMMX instructions: ";
#if USE_MMX
  assert(DidCheckForMMX);
  if (!MMX_Supported) cerr << "not ";
  cerr << "supported\n";
#else
  cerr << "not compiled in\n";
#endif


#elif defined(sparc) && (defined(__sparcv8) || defined(__sparcv9cpu) || defined(__sparcv9))
   cerr << "\nUltra SPARC V9 VIS instructions ";
#if USE_VIS
   cerr << "supported.\n";
#else
   cerr << "not compiled in.\n";
#endif


#endif

#endif


   cerr
     << "\n"
     << "--------------------------------------------------------------------\n"
     << "contact address:\n"
     << "  Dirk Farin <farin@ti.uni-mannheim.de>\n"
     << "  Dept. Circuitry and Simulation / University Mannheim\n"
     << "  B6,26 EG / D-68131 Mannheim / Germany\n"
     << "--------------------------------------------------------------------\n";
}

#include <math/dct2_arai.hh>
int main(int argc,char** argv)
{
#if 0
  srand(4711);
  srand(time(0));

  for (int i=0;i<10000;i++)
    runtests();
  //cout << "Error: " << err << " AbsError: " << abserr << endl;
  exit(0);
  // TestDCT2Accuracy(10000); exit(10);

  IDCT2_AraiAguiNakajima idct;
  idct.RemoveOutputScalefactors();
#endif

  try
    {
      InitOptions();

      struct InputPreprocessor_SingleFrames::Parameter params;
      // EncodingOptions encopts;

 extern char *optarg;
 extern int optind;

      int qscale=8;
      int qscale_type=0;
      int dc_precision=8;
      bool  alt_scan=false;
      uint1 vlc_format=0;
      bool visualize=false;
      const char* visualizetempl=NULL;
      bool miro=true,video4linux=false;
      bool miro_small = false;
      bool show_rms=false;
      //enum MotionEstimationAlgo mv_algo = LogSearch;
      bool DisablePredictionCorrection=false;
      uint32 firstframe=0,lastframe=MASK31;
      bool opt_AccurateMBType=false;
      enum FrameTypeProc opt_frametypeproc = SceneChange;
      bool remote; // Use IRemote
      int v4l_width =384;
      int v4l_height=288;
      int v4l_DecimationFactor=2;
      int crop_top=0,crop_bottom=0,crop_left=0,crop_right=0;
      int framerate=2500;

      //encopts.m_GenerateMPEG1 = false;

      int c;

#if HAVE_GETOPT_LONG
      while ((c = getopt_long(argc,argv,
                              "012bs:e:z:tq:xd:afv:g:p:hmSr3OFXYH:V:N:PT:D:R:JBAMW"
                              ,opts,NULL)) != EOF)
#else
      while ((c = getopt(argc,argv,
                              "012bs:e:z:tq:xd:afv:g:p:hmSr3OFXYH:V:N:PT:D:R:JBAMW")) != EOF)
#endif
	{
	  switch(c)
	    {
	    case Opt_MPEG1:
              options.CreateMPEG2 = false;
	      break;
	    case Opt_MPEG2:
              options.CreateMPEG2 = true;
	      break;
            case Opt_ProgressDisplay:
              {
                int n=atoi(optarg);
                if (n<0 || n>3) { cerr << "WARNING: Verbosity out of range, using default\n"; }
                else options.ProgressDisplay = (Options::ProgressDispl)(n);
              }
              break;
	    case Opt_FirstFrameToLoad:
	      params.m_first_num = firstframe = atoi(optarg);
              options.FirstFrameToLoad = atoi(optarg);
	      break;
	    case Opt_LastFrameToLoad:
	      params.m_last_num  = lastframe = atoi(optarg);
              options.LastFrameToLoad = atoi(optarg);
	      break;
	    case Opt_TargaInput:
	      miro=false;
	      params.m_InputFormat = InputPreprocessor_SingleFrames::Parameter::Format_TGA;
              options.InputFormat=Options::Targa;
	      break;
	    case Opt_PPMInput:
	      miro=false;
	      params.m_InputFormat = InputPreprocessor_SingleFrames::Parameter::Format_PPM;
              options.InputFormat=Options::PPM;
	      break;
	    case Opt_PPMInterlaced:
	      miro=false;
	      params.m_InputFormat = InputPreprocessor_SingleFrames::Parameter::Format_PPM;
              options.InputFormat=Options::PPM;
              options.ppm.Interlaced=true;
	      break;
	    case Opt_Help:
	      usage(argv[0]); exit(5);
	      break;
	    case Opt_FixedQScale:
	      qscale = atoi(optarg);
              assert(qscale>0 && qscale<128);
              options.qscale_const.qscale_I =
              options.qscale_const.qscale_P =
              options.qscale_const.qscale_B = atoi(optarg);
	      break;
	    case Opt_FixedQScale_I:
	      qscale = atoi(optarg);
              assert(qscale>0 && qscale<32);
              options.qscale_const.qscale_I = atoi(optarg);
	      break;
	    case Opt_FixedQScale_P:
	      qscale = atoi(optarg);
              assert(qscale>0 && qscale<32);
              options.qscale_const.qscale_P = atoi(optarg);
	      break;
	    case Opt_FixedQScale_B:
	      qscale = atoi(optarg);
              assert(qscale>0 && qscale<32);
              options.qscale_const.qscale_B = atoi(optarg);
	      break;
	    case Opt_ExponentialQScale:
	      qscale_type=1;
              options.mpeg2.ExponentialQScale=true;
	      break;
	    case Opt_IntraDCPrecision:
	      dc_precision=atoi(optarg); assert(dc_precision>=8 && dc_precision<=11);
              options.mpeg2.DC_Precision=atoi(optarg);
	      break;
	    case Opt_IntraVLCFormat1:
	      vlc_format=1;
              options.mpeg2.IntraVLCFormat=1;
	      break;
	    case Opt_AlternateScan:
	      alt_scan=true;
              options.mpeg2.AlternateScan=true;
	      break;
	    case Opt_GOPLength:
	      options.framepattern.GOPSize =
	      options.scenechange.Lookahead=atoi(optarg);
	      break;
	    case Opt_PDistance:
              options.framepattern.PDistance=
              options.scenechange.PDistance=atoi(optarg);
	      break;
	    case Opt_Visualize:
	      visualize=true;
	      visualizetempl=optarg;
              options.Visualize=true;
	      break;
	    case Opt_MiroAVI:
	      miro=true;
              video4linux=false;
              options.InputFormat=Options::MJPEG_AVI;
	      break;
            case Opt_DecimationFactor:
              v4l_DecimationFactor=atoi(optarg);
              if (v4l_DecimationFactor<1)
                {
                  cerr << "WARNING: decimation factor invalid. Using default (2).\n";
                  v4l_DecimationFactor=2;
                }
              break;
            case Opt_Video4Linux:
              miro=false;
              video4linux=true;
              remote=false;
              break;
            case Opt_Video4LinuxSglStep:
              miro=false;
              video4linux=true;
              remote=true;
              break;
            case Opt_Size:
              sscanf(optarg,"%dx%d",&v4l_width,&v4l_height);
              if (v4l_width<=0 || v4l_height<=0)
                {
                  cerr << "WARNING: size parameter is invald. Using default size.\n";
                }
              else
                {
                  v4l_width +=15; v4l_width  -= v4l_width%16;
                  v4l_height+=15; v4l_height -= v4l_height%16;
                }
              break;
	    case Opt_Miro_SmallPic:
	      miro_small=true;
              options.mjpeg_avi.SmallPic=true;
	      break;
            case Opt_ShowRMS:
              show_rms=true;
              break;
            case Opt_FullSearch:
              options.MVSearchAlgo = Options::FullSearch;
              break;
            case Opt_TSS:
              options.MVSearchAlgo = Options::TSS;
              break;
            case Opt_NTSS:
              options.MVSearchAlgo = Options::NTSS;
              break;
            case Opt_OTS:
              options.MVSearchAlgo = Options::OTS;
              break;
            case Opt_1DFS:
              options.MVSearchAlgo = Options::ODFS;
              break;
            case Opt_NullMV:
              options.MVSearchAlgo = Options::NullMV;
              break;
            case Opt_AccurateMBType:
              opt_AccurateMBType=true;
              options.MBTypeAlgo = Options::MBType_CountBits;
              break;
            case Opt_DisablePredCorrect:
              DisablePredictionCorrection=true;
              options.DisablePredictionCorrection=true;
              break;
            case Opt_SearchWin_H:
              options.HSearchRange=atoi(optarg);
              break;
            case Opt_SearchWin_V:
              options.VSearchRange=atoi(optarg);
              break;
            case Opt_FramePattern:
              opt_frametypeproc=Pattern;
              options.FrameTypeAlgo = Options::FramePattern;
              break;
            case Opt_Threads:
              options.nThreads=atoi(optarg);
              if (options.nThreads<1)
                { 
                  options.nThreads=1;
                  cerr << "Invalid number of threads. Using single thread.\n";
                }
              break;
            case Opt_SaveAudio:
              options.mjpeg_avi.SaveAudio=true;
              break;
#if 1
#if USE_MMX
            case Opt_DisableMMX:
              assert(DidCheckForMMX);
              MMX_Supported=false;
              break;
#endif
#if USE_VIS
            case Opt_DisableVIS:
              VIS_Supported=false;
              break;
#endif
#endif
            case Opt_DisableSomething:
              DisableSomething=true;
              break;

            case Opt_ShowInformation:
              if (strcasecmp(optarg,"DerivVsBits")==0)
                options.Show_DerivVsBits=true;
              break;

            case Opt_Bitrate:
              {
                double rate=atof(optarg);
                if (rate<0.01) rate=0.01;
                options.Enable_CBR_RateControl = true;
                options.Bitrate = (int)(rate*1024*1024);
              }
              break;

            case Opt_JNDControl:
              options.Enable_JND = true;
              break;

            case Opt_LuminanceMasking:
              options.Enable_LuminanceMasking = true;
              break;

            case Opt_ActivityMasking:
              options.Enable_ActivityMasking = true;
              break;

            case Opt_MotionMasking:
              options.Enable_MotionMasking = true;
              break;

            case Opt_CropTop:
              crop_top=atoi(optarg);
              break;

            case Opt_CropBottom:
              crop_bottom=atoi(optarg);
              break;

            case Opt_CropLeft:
              crop_left=atoi(optarg);
              break;

            case Opt_CropRight:
              crop_right=atoi(optarg);
              break;

            case Opt_Framerate100:
              framerate=atoi(optarg);
              break;

	    default:
	      exit(10);
	    }
	}

      if (optind != argc-2)
	{ usage(argv[0]); exit(10); }

  CheckParameterConsistence();

#if 0
#if USE_MMX
  assert(DidCheckForMMX);
  if (MMX_Supported)
    {
      cerr << "MMX detected!\n";
    }
#endif
#endif

      params.m_InputType = InputPreprocessor_SingleFrames::Parameter::ProgressiveFrames;

      InputPreprocessor* preproc = NULL;

      if (miro)
	{
#if DISABLE_MJPEG
	  throw "MJPEG-loader has not been compiled in.";
#else
	  InputPreprocessor_AVI* pre = new InputPreprocessor_AVI;
	  //InputPreprocessor_MiroAVI* pre = new InputPreprocessor_MiroAVI;
	  pre->SetInputFile(argv[optind]);
	  pre->SetFrameRange(firstframe,lastframe);
	  if (miro_small) pre->SetSmallMode();
	  preproc=pre;
          pre->Init();
#endif
	}
      else if (video4linux)
	{
#if DISABLE_V4L
	  throw "Video4Linux-loader has not been compiled in.";
#else
          if (remote)
            {
              InputPreprocessor_V4L_SglStep::V4LParameter v4lparam;
              v4lparam.m_width  = v4l_width;
              v4lparam.m_height = v4l_height;
              v4lparam.m_crop_top    = crop_top;
              v4lparam.m_crop_bottom = crop_bottom;
              v4lparam.m_crop_left   = crop_left;
              v4lparam.m_crop_right  = crop_right;
              v4lparam.m_nFrames = lastframe;
              v4lparam.m_framerate100 = framerate;
              InputPreprocessor_V4L_SglStep* pre = new InputPreprocessor_V4L_SglStep(v4lparam);
              preproc=pre;
            }
          else
            {
              InputPreprocessor_V4L::V4LParameter v4lparam;
              v4lparam.m_width  = v4l_width;  // 256; //24*16; //384;
              v4lparam.m_height = v4l_height; // 192; //18*16; //288;
              v4lparam.m_crop_top    = crop_top;
              v4lparam.m_crop_bottom = crop_bottom;
              v4lparam.m_nFrames = lastframe;
              v4lparam.m_framerate100 = framerate;
              v4lparam.m_decimation_rate = v4l_DecimationFactor;
              InputPreprocessor_V4L* pre = new InputPreprocessor_V4L(v4lparam);
              preproc=pre;
            }
#endif
	}
      else
	{ preproc = new InputPreprocessor_SingleFrames(params,argv[optind]); }

      ofstream ostr(argv[optind+1]);
      StreamSink_OStream outsink(ostr);

      //TaskPool_PicStat tpool(*preproc);
      //TaskPool_Regular tpool(*preproc,outsink);
      TaskPool_AllInOne tpool(*preproc,outsink);

      tpool.SetFrameTypeProc(opt_frametypeproc,
                             (opt_frametypeproc==Pattern) ? options.framepattern.GOPSize :
                                                            options.scenechange.Lookahead);

      tpool.SetIPDistances(options.framepattern.GOPSize,
                           options.framepattern.PDistance);



      struct tms l_times1,l_times2;
      times(&l_times1);

      DoCode(tpool,options.nThreads);

      times(&l_times2);

      double nFrames = preproc->AskNextImageNum();
      double nBytes  = outsink.AskTotalBytesWritten();


      // --- SequenceEnd-Code schreiben ---
      uint8 EndOfSequence[4];
      EndOfSequence[0]=0;
      EndOfSequence[1]=0;
      EndOfSequence[2]=1;
      EndOfSequence[3]=0xB7;
      outsink.WriteBuffer(EndOfSequence,4);

      double usertime;
      cerr << "user time: " << (usertime  =((double)l_times2.tms_utime-l_times1.tms_utime)/HZ) << endl;

      cerr << "realtime-factor: " << usertime/(nFrames/(preproc->AskFramerate100()/100.0)) << endl;
      cerr << "mean bitrate is: "
           << (nBytes*8)/(nFrames/(preproc->AskFramerate100()/100.0))/1024/1024
           << " MBits/sec\n";

      delete preproc;
    }
  catch(char* msg)
    {
      cerr << "ERROR: " << msg << endl;
      return 10;
    }

  /*
  cout << "NRight: " << n_right << "   NFalse: " << n_false << "  "
       << n_right*100.0/(n_right+n_false) << " %\n";
  */

  return 0;
}
