/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "image/codedimg.hh"

Macroblock::Macroblock()
  : m_BeginSlice(false),m_EndSlice(false),
    m_Skip(false)
{
  {for (int i=0;i<4;i++)
    {
      m_y  = &m_blks[0]; m_CodeY  = &m_CodeBlk[0];
      m_cr = &m_blks[4]; m_CodeCr = &m_CodeBlk[4];
      m_cb = &m_blks[8]; m_CodeCb = &m_CodeBlk[8];
    }}

  // Voreinstellung fuer Choma422
  
  {for (int i=0;i<=4;i++) m_CodeBlk[i]=true; }
  {for (int i=5;i<12;i++) m_CodeBlk[i]=false;}
  m_CodeBlk[8]=true;
  m_HasData=true;

  SetFrameMotionType(FRMT_FrameBased);
}

void Macroblock::SetFrameMotionType(FrameMotionType t)
{
  m_frame_motion_type = t;
  m_motion_vector_count = 1;
  switch (t)
    {
    case FRMT_FieldBased:
      m_mv_format = MVFormat_Field;
      m_dmv = 0;
      break;
    case FRMT_FrameBased:
      m_mv_format = MVFormat_Frame;
      m_dmv = 0;
      break;
    case FRMT_DualPrime:
      m_mv_format = MVFormat_Field;
      m_dmv = 1;
      break;
    default:
      assert(0);
      break;
    }
}

void Macroblock::SetFieldMotionType(FieldMotionType t)
{
  m_field_motion_type = t;
  m_mv_format = MVFormat_Field;
  switch (t)
    {
    case FIMT_FieldBased:
      m_motion_vector_count = 1;
      m_dmv = 0;
      break;
    case FIMT_16x8MC:
      m_motion_vector_count = 2;
      m_dmv = 0;
      break;
    case FIMT_DualPrime:
      m_motion_vector_count = 1;
      m_dmv = 1;
      break;
    default:
      assert(0);
      break;
    }
}

#include "image/array2.cc"

template class Array2<Macroblock>;
