/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/
/*
  DCT2_Fast ist kein spezieller Algorithmus, sondern benutzt jeweils den
  schnellsten DCT2 Algorithmus.
 */

#ifndef MATH_DCT2_FAST_HH
#define MATH_DCT2_FAST_HH

#include "math/dct2_separated.hh"
#include "math/dct1_arai.hh"
#include "math/dct1_theoretic.hh"

class DCT2_Fast : public DCT2_Separated
{
public:
  DCT2_Fast()
  {
    for (int i=0;i<9;i++) d_dct1p[i]=&d_dct1[i];
    SetDCT1s(d_dct1p);
  }
  ~DCT2_Fast() { }

private:
  //DCT1_Theoretic d_dct1[9];
  DCT1_AraiAguiNakajima d_dct1[9];
  DCT1* d_dct1p[9];
};

#endif
