/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "measure/rms.hh"
#include "image/image.hh"
#include <math.h>

double CalcRMS(const Image<Pixel>& img1,const Image<Pixel>& img2)
{
  // Der RMS wird alleine im Y-Kanal gemessen.

  const Pixel*const* p1 = img1.AskBitmap_const(Bitmap_Y).AskFrame_const();
  const Pixel*const* p2 = img2.AskBitmap_const(Bitmap_Y).AskFrame_const();

  assert(img1.AskWidth() ==img2.AskWidth());
  assert(img1.AskHeight()==img2.AskHeight());

  int w = img1.AskWidth();
  int h = img1.AskHeight();

  double error=0.0;

  for (int y=0;y<h;y++)
    for (int x=0;x<w;x++)
      error += (p1[y][x]-p2[y][x])*(p1[y][x]-p2[y][x]);

  return sqrt(error/(w*h));
}

double RMS2pSNR(double rms) { return 20*log10(255/rms); }
