/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "options.hh"

Options options;

void InitOptions()
{
  // Multiprozessor-Parameter
  
  options.nThreads = 1;
  
  
  // Misc. Optionen
  
  options.ProgressDisplay = Options::ProgressDisplay_Normal;
  
  
  // Eingabe
  
  options.InputFormat      = Options::MJPEG_AVI;
  options.FirstFrameToLoad = 0;
  options.LastFrameToLoad  = MASK32;
  
  options.mjpeg_avi.SmallPic=false;
  options.mjpeg_avi.BypassNTDriverBug=false;
  options.mjpeg_avi.SaveAudio=false;
  
  
  // Bitstream-Format
  
  options.CreateMPEG2 = true;
  options.CreateElementaryStream = true;
  
  
  // Codierungsoptionen / Video
  
  options.FrameTypeAlgo = Options::SceneChange;
  
  options.framepattern.GOPSize   = 20;
  options.framepattern.PDistance =  5;
  
  options.scenechange.Lookahead = 40;
  options.scenechange.PDistance =  5;
  
  options.MVSearchAlgo = Options::TSS;
  options.QScaleAlgo   = Options::FixedQScale;
  options.MBTypeAlgo   = Options::MBType_Variance;
  
  options.HSearchRange = 8;
  options.VSearchRange = 8;
  
  options.qscale_const.qscale_I = 8;
  options.qscale_const.qscale_P = 8;
  options.qscale_const.qscale_B = 8;
  
  options.Enable_CBR_RateControl   = false;
  options.Enable_JND               = false;
  options.Enable_LuminanceMasking  = false;
  options.Enable_ActivityMasking   = false;
  options.Enable_MotionMasking     = false;
  options.Bitrate=(1024+512)*1024;  // 1.5 Mb/s
  
  
  // MPEG2-spezifische Codierungsoptionen
  
  options.mpeg2.CodeIntraSliceFlag = false;
  options.mpeg2.ExponentialQScale  = false;
  options.mpeg2.AlternateScan      = false;
  options.mpeg2.IntraVLCFormat     = 0;
  options.mpeg2.DC_Precision       = 8;
  
  
  // Debug-Optionen
  
  options.Visualize=false;
  options.DisablePredictionCorrection=false;
  options.Show_DerivVsBits=false;
}

