/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "output/streamsink_vbv.hh"


/* Simuliert wird der Buffer auf Decoderseite */

StreamSink_VBV::StreamSink_VBV(StreamSink& sink,uint32 buffersize,uint32 bitsperfield)
  : d_sink(sink),
    d_buffersize(buffersize),
    d_bitsperfield(bitsperfield)
{
  d_fullness = d_buffersize*7/8;
}

StreamSink_VBV::~StreamSink_VBV()
{
}

void StreamSink_VBV::WriteBuffer(unsigned char* buffer,int length)
{
  if (((uint32)length)*8>d_fullness)
    {
      cerr << "WARNING: buffer underrun\n";
    }

  d_fullness -= length*8;
}

void StreamSink_VBV::AdvanceField()
{
  d_fullness += d_bitsperfield;
  if (d_fullness > d_buffersize)
    {
      cerr << "WARNING: buffer overrun\n";
    }
}
