/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef OUTPUT_STREAMSINK_VBV_HH
#define OUTPUT_STREAMSINK_VBV_HH

#include "output/streamsink.hh"
#include "utility/queue.hh"

class StreamSink_VBV : public StreamSink
{
public:
   StreamSink_VBV(StreamSink& sink,uint32 buffersize /* in Bits */,uint32 bitsperfield);
  ~StreamSink_VBV();

  void WriteBuffer(unsigned char* buffer,int length);
  void AdvanceField();

  uint32 AskBuffersize() const { return d_buffersize; }
  uint32 AskFullness()   const { return d_fullness;   }

  uint32 AskTotalBytesWritten() const { return d_sink.AskTotalBytesWritten(); }

private:
  StreamSink& d_sink;
  uint32      d_buffersize;
  uint32      d_fullness;
  uint32      d_bitsperfield;
};

#endif
