/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef TYPES_HH
#define TYPES_HH

// #include <typeinfo>      // RTTI vertraegt sich bei GCC2.7.2.1 nicht mit 'ifstream'
#include <assert.h>
#include <iostream.h>
#include <iomanip.h>

#ifndef NULL
#define NULL 0
#endif

#ifdef HAS_NO_BOOL
typedef int bool;
#define true  1
#define false 0
#endif

#ifndef BITMAP_ALIGN       /* Alignments <= 128 sind automatisch erfuellt */
#define BITMAP_ALIGN 8
#endif

#define SHOWVAR(x) cout << #x ": " << x << endl;

typedef unsigned long long BitArray;   // Moeglichst grosser Integer-Typ.

typedef unsigned char  uint8;      // Datentyp mit genau 8 Bits
typedef unsigned short uint16;     // Datentyp mit genau 16 Bits
typedef unsigned long  uint32;     // Datentyp mit genau 32 Bits
typedef unsigned long long uint64; // Datentyp mit genau 64 Bits
typedef unsigned char  uint1;
typedef unsigned char  uint2;
typedef unsigned char  uint3;
typedef unsigned char  uint4;
typedef unsigned char  uint5;
typedef unsigned char  uint6;
typedef unsigned char  uint7;
typedef unsigned short uint9;
typedef unsigned short uint10;
typedef unsigned short uint11;
typedef unsigned short uint12;
typedef unsigned short uint13;
typedef unsigned short uint14;
typedef unsigned short uint15;
typedef unsigned long  uint17;
typedef unsigned long  uint18;
typedef unsigned long  uint19;
typedef unsigned long  uint20;
typedef unsigned long  uint21;
typedef unsigned long  uint22;
typedef unsigned long  uint23;
typedef unsigned long  uint24;
typedef unsigned long  uint25;
typedef unsigned long  uint26;
typedef unsigned long  uint27;
typedef unsigned long  uint28;
typedef unsigned long  uint29;
typedef unsigned long  uint30;
typedef unsigned long  uint31;

typedef signed char     int2;
typedef signed long     int32;

// 32 Bitmasken fuer die niederwertigen Bits

const uint32 MASK1 =0x00000001;
const uint32 MASK2 =0x00000003;
const uint32 MASK3 =0x00000007;
const uint32 MASK4 =0x0000000F;
const uint32 MASK5 =0x0000001F;
const uint32 MASK6 =0x0000003F;
const uint32 MASK7 =0x0000007F;
const uint32 MASK8 =0x000000FF;
const uint32 MASK9 =0x000001FF;
const uint32 MASK10=0x000003FF;
const uint32 MASK11=0x000007FF;
const uint32 MASK12=0x00000FFF;
const uint32 MASK13=0x00001FFF;
const uint32 MASK14=0x00003FFF;
const uint32 MASK15=0x00007FFF;
const uint32 MASK16=0x0000FFFF;
const uint32 MASK17=0x0001FFFF;
const uint32 MASK18=0x0003FFFF;
const uint32 MASK19=0x0007FFFF;
const uint32 MASK20=0x000FFFFF;
const uint32 MASK21=0x001FFFFF;
const uint32 MASK22=0x003FFFFF;
const uint32 MASK23=0x007FFFFF;
const uint32 MASK24=0x00FFFFFF;
const uint32 MASK25=0x01FFFFFF;
const uint32 MASK26=0x03FFFFFF;
const uint32 MASK27=0x07FFFFFF;
const uint32 MASK28=0x0FFFFFFF;
const uint32 MASK29=0x1FFFFFFF;
const uint32 MASK30=0x3FFFFFFF;
const uint32 MASK31=0x7FFFFFFF;
const uint32 MASK32=0xFFFFFFFF;

#ifndef Pixel
typedef uint8 Pixel;
#endif
#ifndef MVPixel
typedef uint8 MVPixel;
#endif
/* Wenn Typ(Pixel)==Typ(MVPixel), dann sollte unbedingt noch MVPIX_IS_PIX definiert werden ! */
#ifndef DiffPixel
typedef short DiffPixel;
#endif

// typedef short Pixel2;    // obsolet

// inline int abs(int x) { if (x<0) return -x; else return x; }
inline short  Sign(short i)  { if (i>0) return 1;   if (i<0) return -1;   return 0;   }
inline int    Sign(int i)    { if (i>0) return 1;   if (i<0) return -1;   return 0;   }
inline double Sign(double i) { if (i>0) return 1.0; if (i<0) return -1.0; return 0.0; }
inline float  Sign(float i)  { if (i>0) return 1.0; if (i<0) return -1.0; return 0.0; }
inline void   Swap(double& a,double &b) { double c=a; a=b; b=c; }
inline uint32 min(uint32 a,uint32 b) { if (a>b) return b; else return a; }
inline uint32 max(uint32 a,uint32 b) { if (a>=b) return a; else return b; }
inline  int   min( int   a, int   b) { if (a>b) return b; else return a; }
inline  int   max( int   a, int   b) { if (a>=b) return a; else return b; }
inline double min(double a,double b) { if (a>b) return b; else return a; }
inline double max(double a,double b) { if (a>=b) return a; else return b; }

#endif
