/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef UTILITY_QUEUE_HH
#define UTILITY_QUEUE_HH

#include "types.hh"


template <class T> class Queue
{
public:
  Queue();
  ~Queue();

  void Append(const T&);
  void AppendAtHead(const T&);
  T&   AskHead() const { assert(!IsEmpty()); assert(d_first<d_size); return d_queue[d_first]; }
  T&   AskTail() const;
  T&   AskFromHead(uint32 idx) const;  // 0 ist erstes
  T&   AskFromTail(uint32 idx) const;  // 0 ist letztes
  void RemoveHead();
  void RemoveFromHead(uint32 idx);

  bool   IsEmpty() const { return d_entries==0; }
  uint32 Length()  const { return d_entries;    }

private:
  T*     d_queue;
  uint32 d_size;

  uint32 d_first;
  uint32 d_entries;
};

#endif
