/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef VISUALIZE_WRITEPPM_HH
#define VISUALIZE_WRITEPPM_HH

#include "image/image.hh"
#include "control/datapool.hh"


void OpenStream(class ofstream&,const char* nametemplate,int framenr);
void WriteArrayAsPPM(const Array2<int32>&,const int32& minval,const int32& maxval,class ofstream&,
                     int blksize=16);

void WriteImageAsPPM(const Image<Pixel>&,class ostream&);

Image<Pixel>* CreateVisualizationImage(const Image<Pixel>&,bool centerpoints=true);
Image<Pixel>* CreateDifferenceImage(const Image<DiffPixel>&);
void FillMotionVectors(Image<Pixel>&,const ImageData&);
void FillBlockTypes(Image<Pixel>&,const ImageData&);
void FillBlockClass(Image<Pixel>&,const uint8 cls[100][200]);
void FillBlockClass(Image<Pixel>&,const Array2<uint8>& cls,bool mb=true);

#define BLK_RED   (0x01)
#define BLK_GREEN (0x02)
#define BLK_BLUE  (0x04)

#define BLK_DOTS  (0x08)
#define BLK_RECT  (0x10)
#define BLK_LINE  (0x20)
#define BLK_LINE2 (0x40)
#define BLK_CROSS (BLK_LINE | BLK_LINE2)

#if 0
template <class T> void WriteArrayAsPPM(const Array2<T>&,const T& minval,const T& maxval,class ofstream&);

template void WriteArrayAsPPM(const Array2<uint32>&,const uint32&,const uint32&,class ostream&);
template void WriteArrayAsPPM(const Array2<int32>& ,const  int32&,const  int32&,class ostream&);
template void WriteArrayAsPPM(const Array2<double>&,const double&,const double&,class ostream&);
#endif

// void WriteBitmap(const char* templ,int nr,const Bitmap<Pixel>&);

#endif
